<template>
  <div class="main">
    <div
      v-if="
        processState === 'waiting to start' ||
        processState === 'wrong current password'
      " 
    >
      <div class="w-full max-w-sm">
        <div
          v-if="!resetPassword"
          class="md:flex md:items-center mb-6"
        >
          <div class="md:w-1/3">
            <label
              class="ada-form-label -ml-6"
              for="the-page-change-password--current-password"
            >
              {{ $t('changePassword.form.currentPassword') }}
            </label>
          </div>
          <div class="md:w-2/3">
            <PasswordInput
              v-model="currentPassword"
              @keyup.enter="changePassword"
              input-id="the-page-change-password--current-password"
            />
          </div>
        </div>
        <div class="md:flex md:items-center mb-6">
          <div class="md:w-1/3">
            <label
              class="ada-form-label"
              for="the-page-change-password--new-password"
            >
              {{ $t('changePassword.form.newPassword') }}
            </label>
          </div>
          <div class="md:w-2/3">
            <PasswordInput
              v-model="newPassword"
              @keyup.enter="changePassword"
              input-id="the-page-change-password--new-password"
            />
          </div>
        </div>
        <div class="mb-6">
          <div class="md:flex md:items-center mb-1">
            <div class="md:w-1/3">
              <label
                class="ada-form-label -ml-12"
                for="the-page-change-password--new-password-check"
              >
                {{ $t('changePassword.form.passwordCheck') }}
              </label>
            </div>
            <div class="md:w-2/3">
              <PasswordInput
                v-model="newPasswordCheck"
                @keyup.enter="changePassword"
                input-id="the-page-signup--new-password-check"
              />
            </div>
          </div>
          <div
            v-if="!passwordsAreEqual"
            class="md:flex md:items-center mb-2" 
          >
            <div class="md:w-1/3"></div>
            <div class="md:w-2/3 password-error">
              <p>
                {{ $t('changePassword.messages.passwordError') }}
              </p>
            </div>
          </div>
        </div>

        <div class="md:flex md:items-center">
          <div class="md:w-1/3"></div>
          <div class="md:w-2/3 md:flex md:justify-between md:items-center">
            <div class="md:w-2/3">
              <button
                :class="allFieldsAreOk ? 'ada-button' : 'ada-button-off'"
                type="button"
                @click="changePassword"
              >
                {{ $t('changePassword.actions.changePassword') }}
              </button>
            </div>
            <router-link
              to="/"
              class="ada-button md:w-1/3"
            >
              {{ $t('changePassword.actions.cancel') }}
            </router-link>
          </div>
        </div>
      </div>
      <div
        class="error"
        v-if="processState === 'wrong current password'"
      >
        <p>
          {{ $t('changePassword.process.error') }}
        </p>
        <p class="mt-4">
          {{ $t('changePassword.process.tryAgain') }}
        </p>
      </div>
    </div>
    <div
      class="loading"
      v-if="processState === 'wait for request response'"
    >
      {{ $t('changePassword.process.waitForRequest') }}
    </div>
    <div
      class="loading"
      v-if="processState === 'password is changed'"
    >
      {{ $t('changePassword.process.changePasswordSuccessful') }}
    </div>
    <div
      class="loading"
      v-if="processState === 'no current user'"
    >
      {{ $t('changePassword.process.noCurrentUser') }}
    </div>
  </div>
</template>

<script>
import { ref, computed } from 'vue'
import { useStore, useChangePasswordProcess, useLoginProcess } from '../store.js'
import router from '../router'
import PasswordInput from './PasswordInput.vue'

export default {
  name: 'ThePageChangePassword',
  components: {
    PasswordInput
  },
  props: {
    resetPassword: {
      type: Boolean,
      required: true
    }
  },
  setup (props) {
    const { currentUserId, currentUser } = useStore()
    const { startLoginProcess, loginProcessState } = useLoginProcess()
    const {
      processState,
      startChangePasswordProcess
    } = useChangePasswordProcess()

    const resetPassword = props.resetPassword

    const user = currentUser
    const currentPassword = ref('')
    const newPassword = ref('')
    const newPasswordCheck = ref('')
    const passwordsAreEqual = computed(() => (newPassword.value === newPasswordCheck.value))

    const allFieldsAreOk = computed(() => (
      resetPassword ? 
        newPassword.value &&
        passwordsAreEqual.value
      :
        currentPassword.value &&
        newPassword.value &&
        passwordsAreEqual.value
    ))

    const changePassword = async function () {
      if (resetPassword) {
        await startChangePasswordProcess(newPassword.value)
        if (processState.value === 'user is connected') {
          router.push(`/people/${currentUserId.value}`)
        }
      } else {
        await startLoginProcess(user.value.email, currentPassword.value)
        if (loginProcessState.value === 'user is connected') {
          await startChangePasswordProcess(newPassword.value)
          if (processState.value === 'user is connected') {
            router.push(`/people/${currentUserId.value}`)
          }
        }
        if (loginProcessState.value === 'login is refused') {
          processState.value = 'wrong current password'
        }
      }
    }

    return {
      user,
      resetPassword,
      currentPassword,
      newPassword,
      newPasswordCheck,
      passwordsAreEqual,
      allFieldsAreOk,
      processState,
      changePassword
    }
  }
}
</script>

<style lang="postcss" scoped>
.main {
  @apply m-40;
  @apply flex justify-center;
}

.password-error {
  @apply text-red-400;
  @apply dark:text-red-600;
}

.error {
  @apply m-10 max-w-sm;
  @apply text-xl text-center text-gray-700;
  @apply dark:text-gray-400;
}

.loading {
  @apply max-w-sm;
  @apply text-xl text-gray-700;
  @apply dark:text-gray-400;
}

</style>